'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parse = exports.defaultOpts = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = hljs;

var _highlight = require('highlight.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultOpts = {
  selector: 'pre > code[class*="lang-"]',
  selectorMatcher: /lang-([\w_-]+)/
};
exports.defaultOpts = defaultOpts;
function hljs() {
  var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  opts = (0, _assign2.default)({}, defaultOpts, opts);
  return function ($) {
    var codeElems = $(opts.selector);
    codeElems.each(function (idx, elem) {
      var _parse = parse($, elem, opts.selectorMatcher),
          $elem = _parse.$elem,
          lang = _parse.lang,
          code = _parse.code;

      if (!lang) {
        return;
      }

      var result = (0, _highlight.highlight)(lang, code);
      $elem.text(result.value);
    });
    return $;
  };
}
hljs.registerLanguage = _highlight.registerLanguage;

function parse($, elem, matcher) {
  var $elem = $(elem);
  var matches = $elem.attr('class').match(matcher);
  if (!matches) {
    return { $elem: null, lang: null, code: null };
  }

  var lang = matches[1];
  var code = $elem.text();
  return { $elem: $elem, lang: lang, code: code };
}
exports.parse = parse;