'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = maku;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _marked = require('marked');

var _marked2 = _interopRequireDefault(_marked);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function maku() {
  var rendererFuncs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var plugins = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  var renderer = _marked2.default;
  if ((typeof rendererFuncs === 'undefined' ? 'undefined' : (0, _typeof3.default)(rendererFuncs)) === 'object') {
    var _renderer = new _marked2.default.Renderer();
    (0, _assign2.default)(_renderer, rendererFuncs);
    renderer = function (opts) {
      return function (markdown) {
        return (0, _marked2.default)(markdown, opts);
      };
    }({ renderer: _renderer });
  }

  return {
    process: function process(markdownpath) {
      var _this = this;

      return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var markdown, result;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                markdown = null;
                _context.prev = 1;
                _context.next = 4;
                return readFile(markdownpath);

              case 4:
                markdown = _context.sent;
                _context.next = 10;
                break;

              case 7:
                _context.prev = 7;
                _context.t0 = _context['catch'](1);
                throw _context.t0;

              case 10:
                result = renderer(markdown);


                if (Array.isArray(plugins)) {
                  result = plugins.reduce(function (html, plugin) {
                    // Set `decodeEntities` because Japanese garbles
                    var $ = _cheerio2.default.load(html, {
                      decodeEntities: false
                    });
                    var value = plugin($, _cheerio2.default);

                    if (typeof value === 'string') {
                      return value;
                    }
                    return $.html();
                  }, result);
                }

                return _context.abrupt('return', result);

              case 13:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this, [[1, 7]]);
      }))();
    }
  };
}

function readFile(filepath) {
  return new _promise2.default(function (resolve, reject) {
    _fs2.default.readFile(filepath, 'utf-8', function (err, content) {
      if (err) {
        reject(err);
        return;
      }
      resolve(content);
    });
  });
}